
import java.lang.reflect.Array;
import java.time.LocalDate;
import java.util.Collection;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class Checkbook{

    private List<Transaction> checkbook;
    private Payee owner;
    private Double cashAmount;

    public Checkbook() {
        this.checkbook = new ArrayList<>();
    }

    public Checkbook(Payee owner, Double cashAmount) {
        this.owner = owner;
        this.cashAmount = cashAmount;
        this.checkbook = new ArrayList<>();
    }

    public Checkbook(Double cashAmount) {
        this.cashAmount = cashAmount;
        this.checkbook = new ArrayList<>();
    }

    public int size(){
        return checkbook.size();
    }

    public Boolean isEmpty(){
        return checkbook.isEmpty();
    }

    public Boolean remove(Transaction transaction){
        return checkbook.remove(transaction);
    }

    public void add(Transaction newTransaction){
        checkbook.add(newTransaction);
    }

    public Boolean contains(Transaction newTransaction){
        return checkbook.contains(newTransaction);
    }

    public Iterator iterator() {
        return checkbook.iterator();
    }

    public Transaction[] toArray(){
        return checkbook.toArray(new Transaction[0]);
    }

    public Double checkbookValue(){
        Double credit = 0.0;
        Double debit = 0.0;
        Double total = credit + debit;
        for(Transaction transaction : checkbook){
            if(transaction.getType() == TransactionType.DEBIT) {
                debit += transaction.getAmount();
            } else {
                credit += transaction.getAmount();
            }
        }
        return cashAmount + total;
    }

    public Transaction[] getTransactionForDate(LocalDate date){
        ArrayList<Transaction> list = new ArrayList<>();
        for(Transaction transaction : checkbook) {
            if(transaction.getDate() == date) {
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[0]);
    }

    public Transaction[] getAllTransactionsForPayee(Payee payee){
        ArrayList<Transaction> list = new ArrayList<>();
        for(Transaction transaction : checkbook) {
            if(transaction.getPayee() == (payee)) {
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[0]);
    }

    public Transaction[] getAllDebitTransactions(){
        ArrayList<Transaction> list = new ArrayList<>();
        for(Transaction transaction: checkbook) {
            if(transaction.getType() == TransactionType.DEBIT) {
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[0]);
    }

    public Transaction[] getAllCreditTransactions(){
        ArrayList<Transaction> list = new ArrayList<>();
        for(Transaction transaction : checkbook) {
            if(transaction.getType() == TransactionType.CREDIT) {
                list.add(transaction);
            }
        }
        return list.toArray(new Transaction[0]);
    }

    public void clear(){
        checkbook.clear();
    }

    public Boolean removeAll(Collection collection){
        return this.removeAll(collection);
    }

    public Boolean addAll(Collection collection){
        return this.addAll(collection);
    }

    public Boolean containsAll(Collection collection){
        return this.containsAll(collection);
    }






}
